//  created:    2013/06/26
//  filename:   Measure.cpp
//
//  author:     Guillaume Sanahuja
//              Copyright Heudiasyc UMR UTC/CNRS 7253
//
//  version:    $Id: $
//
//  purpose:    objet permettant la generation de measures
//
//
/*********************************************************************/

//on inclut le header de la classe
#include "Measure.h"
//on inclut les headers des classes seulement déclarées dans Sinus.h (forward declaration)
#include <FrameworkManager.h>
#include <TabWidget.h>
#include <Tab.h>
#include <GridLayout.h>
#include <GroupBox.h>
#include <DoubleSpinBox.h>
#include <SpinBox.h>
#include <DataPlot1D.h>
#include <cvmatrix.h>
#include <stdio.h>
#include <fstream>


//on utilise le namespace std, ce qui évite d'écrire par exemple std::string
using namespace std;
using namespace Kalman;
using namespace framework::gui;

namespace framework
{
namespace core
{
//constructeur, on hérite de IODevice et Thread
Measure::Measure(const FrameworkManager* parent,string name,int priority) : IODevice(parent,name),Thread(parent,name,priority)
{
    //initialisation de quelques variables
    is_started=false;
    plot_r=NULL;
    plot_theta=NULL;

    //initialisation interface
    main_tab=new Tab(parent->GetTabWidget(),name);//onglet principal
    tabwidget=new TabWidget(main_tab->NewRow(),name);//conteneur d'onglets secondaires
	Tab* reglages_tab=new Tab(tabwidget,"Reglages");//onglet secondaire des réglages
    period=new SpinBox(reglages_tab->NewRow(),"period thread (ms):",1,1000,1);//période du Thread

    setup_layout=new GridLayout(reglages_tab->NewRow(),"setup");//layout qui servira à placer des filtres par exemple

    //matrice 1*2 de sortie
    //Measure dérive de Thread et IODevice, tous les deux dérivant de Object
    //on explicite que l'Object parent de la cvmatrix et l'IODevice du Measure
    cvmatrix_descriptor* desc=new cvmatrix_descriptor(1,2);
    desc->SetElementName(0,0,"theta");//le nom servira pour la légende du graphe
    desc->SetElementName(0,1,"r");
    output=new cvmatrix((IODevice*)this,desc,floatType,name);

    //on spécifie les données à enregistrer (logs)
    AddDataToLog(output);

    //on recupere les données dans les fichiers comme dans l'exemple de la librairie
    ifstream dataInput;
	string tmpStr;
	measure= new KMatrix<double, 1, true>(2,NTRY);

    // Matlab format
	selectKVectorContext(createKVectorContext(" ", "[ ", " ];", 4));
	selectKMatrixContext(createKMatrixContext(" ", " ;\n  ", "[ ", " ];", 4));
	dataInput.open("./measure.m",ifstream::in);

	if (dataInput.fail())
	{
		cout<<"Unable to open input file!"<<endl;
	}

	//Read the measures matrix. This matrix have been generated by the Matlab script <generation.m>
	dataInput>>tmpStr;
	dataInput>>tmpStr;
	dataInput>>(*measure);

	if (dataInput.fail())
	{
		cout<<"IO error!"<<endl;
	}

	dataInput.close();

    //on initialise output
	index=2;
	output->SetValue(0,0,(*measure)(1,1));
    output->SetValue(0,1,(*measure)(2,1));
}

//destructeur
Measure::~Measure()
{
    //on force is_started à false, la function Run va s'arréter toute seule
    is_started=false;
    //on attend que le Thread soit fini, c'est à dire que l'on quitte la fonction Run
    Join();

    delete measure;
    delete main_tab;
    //l'ensemble des objet créés et ayant pour parent cette classe seront automatiquement détruits
}

void Measure::UseDefaultPlot(void)
{
    Tab* plot_tab=new Tab(tabwidget,"Graphe");//onglet secondaire pour le graphe
        plot_theta=new DataPlot1D(plot_tab->NewRow(),"theta",0,3.5);//le graphe
            plot_theta->AddCurve(output->Element(0));//la courbe de la matrice Output(0,0)
        plot_r=new DataPlot1D(plot_tab->NewRow(),"r",0,3000);//le graphe
            plot_r->AddCurve(output->Element(1));//la courbe de la matrice Output(0,0)
}

//accesseur pour setup_layout
//il est plus propre de faire une fonction accesseur plutot que de mettre la variable setup_layout publique
GridLayout* Measure::SetupLayout(void) const
{
    return setup_layout;
}

DataPlot1D* Measure::PlotR(void) const
{
    //attention, si l'on a pas appellé UseDefaultPlot avant, plot est inutilisable
    if(plot_r==NULL) printf("Measure::Plot, attention plot non défini, voir UseDefaultPlot\n");
    return plot_r;
}

DataPlot1D* Measure::PlotTheta(void) const
{
    //attention, si l'on a pas appellé UseDefaultPlot avant, plot est inutilisable
    if(plot_theta==NULL) printf("Measure::Plot, attention plot non défini, voir UseDefaultPlot\n");
    return plot_theta;
}

//accesseur pour Output
//il est plus propre de faire une fonction accesseur plutot que de mettre la variable output publique
cvmatrix *Measure::Output(void) const
{
    return output;
}

float Measure::R(void) const
{
   return output->Value(0,1);
}

float Measure::Theta(void) const
{
   return output->Value(0,0);
}

//la boucle du Thread
void Measure::Run(void)
{
    //on fixe la période du Thread
    SetPeriodMS(period->Value());
    is_started=true;

    //permet d'avertir si l'on fait des changements du mode temps réél au mode normal
    WarnUponSwitches(true);

    //boucle tant que is_started est true
    //seul le destructeur peut changer cette valeur et arréter la boucle
    while(is_started==true)
    {
        //on synchronise avec la période
        WaitPeriod();
        //si la valeur de la box a changé, on fixe la période du Thread
        if(period->ValueChanged()==true) SetPeriodMS(period->Value());

        //on recupere les valeurs dans les tableaux
        output->SetValue(0,0,(*measure)(1,index));
        output->SetValue(0,1,(*measure)(2,index));
        if(index<NTRY-1) index++;

        //on place le temps corresponcant à la valeur du signal dans la matrice de sortie
        output->SetDataTime(GetTime());

        //ProcessUpdate est très important, il faut obligatoirement l'appeler après avoir mis à jour la matrice de sortie
        //cela permet:
        // d'enregistrer la matrice se sortie dans les logs
        // de mettre à jour automatiquement les filtres suivants (dans notre cas le passe bas et le moyenneur)
        ProcessUpdate(output);

    }

    WarnUponSwitches(false);
}
}//end namespace core
}//end namespace framework
